
C Program simply reads through a standard polh_gen ctr file and repeats the
C output with relevant (current) mods according to environment variables.

	CHARACTER*78	line
	CHARACTER*60	eg_path, molecule_coords
	CHARACTER*4	flag

1100	FORMAT (A78)
1200	FORMAT (A4)

	CALL	GETENV ('EXAMPLES', eg_path)
	CALL	leader (eg_path, iep)
	CALL	GETENV ('MOLECULE_COORDS', molecule_coords)
	CALL	leader (molecule_coords, imc)

	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/polh_gen_std.ctr')
Clnx	OPEN (UNIT=2, NAME='polh_gen_'//molecule_coords(1:imc)//'.ctr',
Clnx     1	      TYPE='NEW', CARRIAGECONTROL='LIST')
	OPEN (UNIT=2, NAME='polh_gen_'//molecule_coords(1:imc)//'.ctr',
     1	      TYPE='NEW')

200	READ (1,1100,END=500) line
	READ (line,1200) flag
	IF (flag .EQ. 'CRDS') THEN
	  WRITE (2,1100) line
	  READ (1,*)
	  READ (1,*)
	  WRITE (2,*) molecule_coords (1:imc)//'_es.pdb'
	  WRITE (2,*) molecule_coords (1:imc)//'_esH.pdb'
	ELSE
	  WRITE (2,1100) line
	END IF
	GOTO 200

500	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
	CALL	EXIT
	END


	SUBROUTINE	leader (char_array, itop)
C	**********	******

	CHARACTER*60	char_array

	itop	= 1
	DO WHILE (char_array (itop:itop) .NE. ' ')
	  itop	= itop + 1
	END DO
	itop	= itop - 1

	RETURN
	END






