
C A real cludge of a program this one - get the current charge bits from
C the 'charge_cen.dat' file deposited by fd_manager, but then we need to
C match these xyz back to 'coord_ind.pep' to get the atom types for the
C dictionary look-up to get the radii.  Then do shell accessibility
C calculations with each of the charge centres and the protein/iso aa
C grids, and then average over the charge bits.  Do this for the focus
C grid only.

C Updated Aug.98 for a third grid with iso aa+mc+CBs.

	REAL		diel_1 (150,150,150), diel_2 (150,150,150),
     1			diel_3 (150,150,150)
	REAL		dgrid_zero (3), xyzh (3), xyz_q (10,3),
     1			fraction (10,3)
	INTEGER		dgrid_dims (3), ijk_under (3),
     1			ijk_min (3), ijk_max (3), n_shell (10),
     2			n_prot_1 (10), n_prot_2 (10), n_prot_3 (10)
	CHARACTER*80	header
	REAL		at_VdW (100,10), at_chrg (2000,4),
     1			at_pK (2000)
	INTEGER		which_VdW,
     2			n_res_ats (200), nat_pter (200,2),
     3			at_class (2000), common_pter (100)
	CHARACTER*34	at_info (100)
	LOGICAL*1	at_anyq (2000), at_ionise (2000), common_at
	CHARACTER*4	common_atyp (100), res_type (200),
     1			at_type (2000), at_prtner (2000),
     2			fix_res (10000), fix_atyp (10000),
     3			rgps (355)
	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			fix_xyz (3,10000), fix_q (10000),
     4			gps_sum (355,4), Vf (355,3)
	INTEGER		qopind (355,10,4), fix_nres (10000),
     1			igps (355,4), igps_nres (355), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*80	mol_label
	LOGICAL*1	done (355,2,3,4)
	CHARACTER*8	state
	CHARACTER*4	gps_type (355), atyp, atm
	CHARACTER*1	cgps (355), fix_chain (10000)
	CHARACTER*20	ch_here
	LOGICAL		extra_runs
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60),
C ?? 1			coords_file (5,60), curr_coords_file (60)

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo
	COMMON	/atoms_es_type/ at_info, n_at_types, at_VdW, n_VdW
	COMMON	/atoms_es_resi/	n_res_types, n_chrg, n_all_at,
     1				res_type, n_res_ats, nat_pter,
     2				at_type, at_class, at_chrg,
     3				at_anyq, at_ionise, at_pK,
     4				at_prtner
	COMMON	/common_atoms/	common_atyp, common_pter, n_common
	COMMON	/i_vdw/		which_VdW

1100	FORMAT (A80)
1200	FORMAT (A4,9X,A4,A4,1X,I4,4X,3F8.3)
2000	FORMAT (I1,1X,I4)
2200	FORMAT (3F8.3)
3000	FORMAT (/,' for i_gp,res,nres,n_bits,rad_atom = ',
     1 I4,1X,A4,1X,I4,1X,I1,1X,F8.3)
3100	FORMAT (20X,'with step = ',F8.3,' and 2.8 A water')
3200	FORMAT (' i_charge_bit = ',I1,' acc frns
     1 prot/iso/mc_bg = ',F8.3,2X,F8.3,2X,F8.3)
3300	FORMAT (' protein, iso aa, mc_bg frns = ',3(F8.3,2X))
3400	FORMAT (' iso-prot,       iso-bg frns = ',F8.3,12X,F8.3)

C I an afraid that we are getting which_VdW from the 'fd_manager.com'
C file, since it does not carry through all fd_manager runs.

C No actually, Sep 2001 update to use getenv to pass environment variable.

C ??	READ (5,*) which_VdW

	CALL	getenv ('which_vdw', ch_here)
	IF 	(ch_here (1:1) .EQ. '1') THEN
	  which_VdW	= 1
	ELSE IF (ch_here (1:1) .EQ. '2') THEN
	  which_VdW	= 2
	ELSE IF (ch_here (1:1) .EQ. '3') THEN
	  which_VdW	= 3
	ELSE
	  STOP 'ERROR: which_vdw to vol_frac'
	END IF

	CALL	read_atoms_es

	OPEN (UNIT=1, NAME='charge_cen.dat', TYPE='OLD')
	READ (1,2000) n_bits, i_gp_hereV
	DO 200 ib	= 1, n_bits
	  READ (1,2200) (xyz_q (ib,n), n=1,3)
200	CONTINUE						! End ib
	CLOSE (UNIT=1)

C Get the vdw radius for the first charge bit - assume all the same.
C Go back to 'coords_ind.pep", and match xyz to get atyp, res.

	OPEN (UNIT=1, NAME= 'coords_ind.pep', TYPE='OLD')
	READ (1,1100) header
220	READ (1,1200,END=240) atm, atyp, res, nres, xyzh
	del_xyz		= SQRT ( (xyzh (1)-xyz_q (1,1))**2 +
     1				 (xyzh (2)-xyz_q (1,2))**2 +
     2				 (xyzh (3)-xyz_q (1,3))**2 )
	IF (del_xyz .LT. 0.01) THEN
	  IF (atm .NE. 'ATOM' .AND. atm .NE. 'HETA') STOP 'VF/atm'
	  common_at	= .FALSE.
	  DO 230 i_com	= 1, n_common
	    IF (atyp .EQ. common_atyp (i_com)) THEN
	      iat	= common_pter (i_com)
	      common_at	= .TRUE.
	    END IF
230	  CONTINUE						! End i_com
	  IF (.NOT. common_at) THEN
	    CALL	res_id (res, ir, ia_1, ia_2, na)
	    CALL	atom_id (atyp, iat, ia_1, ia_2)
	  END IF
	  ic			= at_class (iat)
	  rad_atom		= at_VdW (ic,which_VdW)
	  IF (rad_atom .LT. 0.95) STOP 'VF/rad_atom'
	  GOTO 260
	END IF
	GOTO 220

240	STOP 'VF/no atom match'

260	CLOSE (UNIT=1)
	r_1		= rad_atom
	r_2		= rad_atom + 2.8

	OPEN (UNIT=1,NAME='fd93_1_a.dlc',FORM='UNFORMATTED',
     1        TYPE='OLD')
	READ (1) dgrid_zero, dgrid_dims, step
	OPEN (UNIT=2,NAME='fd93_2_a.dlc',FORM='UNFORMATTED',
     1        TYPE='OLD')
	READ (2)
	OPEN (UNIT=3,NAME='fd93_3_a.dlc',FORM='UNFORMATTED',
     1        TYPE='OLD')
	READ (3)
	iemax		= dgrid_dims (1)
	jemax		= dgrid_dims (2)
	kemax		= dgrid_dims (3)
	DO 300 k	= 1, kemax
	  DO 300 j	= 1, jemax
	    READ (1) (diel_1 (i,j,k), i=1,iemax)
	    READ (2) (diel_2 (i,j,k), i=1,iemax)
	    READ (3) (diel_3 (i,j,k), i=1,iemax)
300	CONTINUE						! End j,k
	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
	CLOSE (UNIT=3)
	max_rad		= 3 + INT (r_2/step)

	DO 400 ib	= 1, n_bits
	  DO 340 n	= 1, 3
	    ijk_under (n) = 1+INT((xyz_q(ib,n)-dgrid_zero(n))/step)
	    ijk_min (n)	  = ijk_under (n) - max_rad
	    ijk_max (n)	  = ijk_min (n) + 2*max_rad + 1
340	  CONTINUE						! End n
	  n_shell (ib)	= 0
	  n_prot_1 (ib)	= 0
	  n_prot_2 (ib)	= 0
	  n_prot_3 (ib)	= 0
	  DO 360 i	= ijk_min (1), ijk_max (1)
	    x		= dgrid_zero (1) + step*FLOAT (i-1)
	    DO 360 j	= ijk_min (2), ijk_max (2)
	      y		= dgrid_zero (2) + step*FLOAT (j-1)
	      DO 360 k	= ijk_min (3), ijk_max (3)
	        z	= dgrid_zero (3) + step*FLOAT (k-1)
	        rad	= SQRT ( (x-xyz_q (ib,1))**2 +
     1				 (y-xyz_q (ib,2))**2 +
     2				 (z-xyz_q (ib,3))**2 )
		IF (rad .LE. r_2) THEN
		  IF (rad .GE. r_1) THEN
		    n_shell (ib) = n_shell (ib) + 1
		    IF (diel_1 (i,j,k) .LT. 10.) THEN
		      n_prot_1 (ib) = n_prot_1 (ib) + 1
		    END IF
		    IF (diel_2 (i,j,k) .LT. 10.) THEN
		      n_prot_2 (ib) = n_prot_2 (ib) + 1
		    END IF
		    IF (diel_3 (i,j,k) .LT. 10.) THEN
		      n_prot_3 (ib) = n_prot_3 (ib) + 1
		    END IF
		  END IF
	        END IF
360	  CONTINUE						! End k,j,i
	  fraction (ib,1) = 1.-FLOAT(n_prot_1(ib))/FLOAT(n_shell(ib))
	  fraction (ib,2) = 1.-FLOAT(n_prot_2(ib))/FLOAT(n_shell(ib))
	  fraction (ib,3) = 1.-FLOAT(n_prot_3(ib))/FLOAT(n_shell(ib))
400	CONTINUE						! End ib

C At present we'll just put this information out to the 'fd_manager.inf'
C file - we'll want to put it into 'fd_manager.out' at some stage.

	OPEN (UNIT=1, NAME='fd_manager.inf', TYPE='OLD',
     1        ACCESS='APPEND')
	WRITE (1,3000) i_gp_hereV, res, nres, n_bits, rad_atom
	WRITE (1,3100) step
	tot_1		= 0.
	tot_2		= 0.
	tot_3		= 0.
	DO 500 ib	= 1, n_bits
	  WRITE (1,3200) ib, fraction (ib,1), fraction (ib,2),
     1			     fraction (ib,3)
	  tot_1		= tot_1 + fraction (ib,1)
	  tot_2		= tot_2 + fraction (ib,2)
	  tot_3		= tot_3 + fraction (ib,3)
500	CONTINUE						! End ib
	av_1		= tot_1 / FLOAT (n_bits)
	av_2		= tot_2 / FLOAT (n_bits)
	av_3		= tot_3 / FLOAT (n_bits)
	WRITE (1,3300) av_1, av_2, av_3
	WRITE (1,3400) av_2-av_1, av_2-av_3
	CLOSE (UNIT=1)

C Updated September 1998 to have updated link to the data file.
C These are fractional accessibilities over something like averaged first
C hydration shells.

	CALL	read_data (i_gp_hereV)
	Vf (i_gp_hereV,1)	= av_1
	Vf (i_gp_hereV,2)	= av_2
	Vf (i_gp_hereV,3)	= av_3
	CALL	write_data

	CALL	EXIT
	END


	SUBROUTINE	read_data (i_gp_hereV)
C	**********	*********

C Read in the charge interaction data, and see where we are up to.

	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			fix_xyz (3,10000), fix_q (10000),
     4			gps_sum (355,4), Vf (355,3)
	CHARACTER*4	gps_type (355), fix_atyp (10000),
     1			fix_res (10000), rgps (355)
	CHARACTER*1	cgps (355), fix_chain (10000)
	INTEGER		qopind (355,10,4), fix_nres (10000),
     1			igps (355,4), igps_nres (355), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*8	state
	CHARACTER*80	mol_label, this_line
	LOGICAL		extra_runs
	LOGICAL*1	done (355,2,3,4)
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60),
C ?? 1			coords_file (5,60), curr_coords_file (60)

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo

1300	FORMAT (A80)

C ?? - is this all variable record lengths?
	OPEN (UNIT=1, NAME='fd_manager.out', TYPE='OLD',
     1	      FORM='UNFORMATTED')

	READ (1) mol_label
	READ (1) i_gp_here, i_Q_here
	READ (1) n_Q_sets, i_Q_done, i_Q_todo, (Q_set (j), j=1,5),
     1		  (Q_file (j), j=1,5)
	READ (1) (coords_file (j), j=1,5)
	READ (1) n_gps, (nq_gps (m), m=1,4), extra_runs

C ?? karolinska - this general variable size needs tiding
	IF (n_gps .GT. 355) STOP 'vol_frac/355'

	READ (1) ((igps (i,j), j=1,4), i=1,n_gps),
     1		 (igps_nres (i), i=1,n_gps),
     2		 (cgps (i), i=1,n_gps)
	READ (1) (((ind_xyz (i,j,k), k=1,4), j=1,10), i=1,n_gps)
	READ (1) (rgps(i),i=1,n_gps),((gps_sum(i,j),j=1,4),i=1,n_gps)
	READ (1) (gps_type (i), i=1,n_gps)
	READ (1) ((((done (i,j,k,m), m=1,4),k=1,3), j=1,2), i=1,n_gps)
	READ (1) (((((se (i,j,k,l,m), m=1,4),l=1,10), k=1,3), j=1,2),
     1		      i=1,n_gps)
	READ (1) (((char (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	READ (1) ((((xyz (i,j,k,m), m=1,4), k=1,3),j=1,10), i=1,n_gps)
	READ (1) ((((fix (i,j,k,m), m=1,4),k=1,3), j=1,2), i=1,n_gps)
	READ (1) (((((gpij(i,j,k,l,m), m=1,4), l=1,10), k=1,n_gps),
     1		      j=1,3), i=1,n_gps)
	READ (1) (pKint (i), i=1,n_gps)
	READ (1) ((Vf (i,j), j=1,3), i=1,n_gps)
	READ (1) (((qopind (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	READ (1) nq_fix
	DO 200 i	= 1, nq_fix
	  READ (1) (fix_xyz (j,i), j=1,3), fix_q (i), fix_res (i),
     1		    fix_atyp (i), fix_nres (i), fix_chain (i)
200	CONTINUE						! End i

C Just check that we agree on where we are.

	IF (i_gp_hereV .NE. i_gp_here) STOP 'i_gp mismatch/vol_frac'

	RETURN
	END


	SUBROUTINE	write_data
C	**********	**********

C Write out the complete fd_manager.out file.

	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			fix_xyz (3,10000), fix_q (10000),
     4			gps_sum (355,4), Vf (355,3)
	INTEGER		qopind (355,10,4), fix_nres (10000),
     1			igps (355,4), igps_nres (355), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*80	mol_label
	LOGICAL*1	done (355,2,3,4)
	CHARACTER*8	state
	CHARACTER*4	gps_type (355), fix_res (10000),
     1			fix_atyp (10000), rgps (355)
	CHARACTER*1	cgps (355), fix_chain (10000)
	LOGICAL		extra_runs
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60),
C ?? 1			coords_file (5,60), curr_coords_file (60)

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo

C ?? - is this all variable record lengths?
C balls up	OPEN (UNIT=1, NAME='fd_manager.out', TYPE='NEW',
C balls up     1	      FORM='UNFORMATTED')

	REWIND (UNIT=1)

	WRITE (1) mol_label
	WRITE (1) i_gp_here, i_Q_here
	WRITE (1) n_Q_sets, i_Q_done, i_Q_todo, (Q_set (j), j=1,5),
     1		  (Q_file (j), j=1,5)
	WRITE (1) (coords_file (j), j=1,5)
	WRITE (1) n_gps, (nq_gps (m), m=1,4), extra_runs
	WRITE (1) ((igps (i,j), j=1,4), i=1,n_gps),
     1		  (igps_nres (i), i=1,n_gps),
     2		  (cgps (i), i=1,n_gps)
	WRITE (1) (((ind_xyz (i,j,k), k=1,4), j=1,10), i=1,n_gps)
	WRITE (1) (rgps(i),i=1,n_gps),((gps_sum(i,j),j=1,4),i=1,n_gps)
	WRITE (1) (gps_type (i), i=1,n_gps)
	WRITE (1) ((((done (i,j,k,m), m=1,4), k=1,3), j=1,2),
     1		      i=1,n_gps)
	WRITE (1) (((((se (i,j,k,l,m), m=1,4), l=1,10), k=1,3),
     1		       j=1,2), i=1,n_gps)
	WRITE (1) (((char (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	WRITE (1) ((((xyz (i,j,k,m), m=1,4), k=1,3),j=1,10),i=1,n_gps)
	WRITE (1) ((((fix (i,j,k,m), m=1,4), k=1,3), j=1,2),i=1,n_gps)
	WRITE(1) (((((gpij(i,j,k,l,m), m=1,4), l=1,10), k=1,n_gps),
     1		     j=1,3), i=1,n_gps)
	WRITE (1) (pKint (i), i=1,n_gps)
	WRITE (1) ((Vf (i,j), j=1,3), i=1,n_gps)
	WRITE (1) (((qopind (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	WRITE (1) nq_fix
	DO 200 i	= 1, nq_fix
	  WRITE (1) (fix_xyz (j,i), j=1,3), fix_q (i), fix_res (i),
     1		     fix_atyp (i), fix_nres (i), fix_chain (i)
200	CONTINUE						! End i

	CLOSE (UNIT=1)

	RETURN
	END






